
''' Teilaufgaben 1c) und 1d) '''

import matplotlib.pyplot as plt
import matplotlib.colors as colors
import numpy as np
import math


def convolve(image, matrix):
           
        # Neues Bild anlegen:
        h, w = image.shape
        result = np.zeros((h, w))        
        
        # Alle Pixel durchgehen:
        for y in xrange(h):
            print "Convolution working at row", y, "..."
            for x in xrange(w):
                result[y, x] = convolveAt(image, x, y, matrix)
        
        # Ergebnis zurueckgeben:
        return result
    
    
def convolveAt(image, x, y, matrix):
        h, w = image.shape
        m, n = matrix.shape
        m = int(math.floor(m/2))
        n = int(math.floor(n/2))
        sum = 0
        for my in xrange(-m, m+1):
            for mx in xrange(-n, n+1):
                sum += matrix[my+m, mx+n] * image[max(0, min(h-1, y + my)), max(0, min(w-1, x + mx))]
        return sum
    
    
def boxcarBlur(image, m, n):
    matrix = np.ones((m, n))
    matrix = matrix * 1.0/(m*n)
    return convolve(image, matrix)



def createGaussianKernel(n, sigma):
    
    a = 1.0/(sigma * math.sqrt(2*math.pi) )
    b = 1.0/(2*sigma*sigma)
    
    matrix = np.ones((n, n))
    for y in xrange(n):
        for x in xrange(n):
            xV = (x - int(n/2.0))
            yV = (y - int(n/2.0))
            matrix[y, x] = a * math.exp(-b * (xV*xV+yV*yV) )
    
    matrix = matrix / np.sum(matrix) #Normalisieren.
    return matrix


def gaussianBlur(image, n, sigma):
    matrix = createGaussianKernel(n, sigma)
    return convolve(image, matrix)


    
    
def aufgabe1c():
    input = plt.imread('ente.png')
    resultBoxcar = boxcarBlur(input, 5, 5)
    resultGaussian = gaussianBlur(input, 5, 5)
    plt.figure(1)
    plt.subplot(131)
    plt.imshow(input, cmap=plt.cm.gray, norm=colors.NoNorm())
    plt.subplot(132)
    plt.imshow(resultBoxcar, cmap=plt.cm.gray, norm=colors.NoNorm())
    plt.subplot(133)
    plt.imshow(resultGaussian, cmap=plt.cm.gray, norm=colors.NoNorm())
    plt.show()
    
    
def aufgabe1d():
    input = plt.imread('ente.png')
    resultGaussian = gaussianBlur(input, 5, 0.5)
    resultGaussian2 = gaussianBlur(input, 5, 1)
    resultGaussian3 = gaussianBlur(input, 5, 5)
    plt.figure(1)
    plt.subplot(221)
    plt.imshow(input, cmap=plt.cm.gray, norm=colors.NoNorm())
    plt.subplot(222)
    plt.imshow(resultGaussian, cmap=plt.cm.gray, norm=colors.NoNorm())
    plt.subplot(223)
    plt.imshow(resultGaussian2, cmap=plt.cm.gray, norm=colors.NoNorm())
    plt.subplot(224)
    plt.imshow(resultGaussian3, cmap=plt.cm.gray, norm=colors.NoNorm())
    plt.show()
    
    
aufgabe1c()
#aufgabe1d()
